// KunSirka.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <iomanip>

using namespace std;

#define SirkaPole	4
#define VyskaPole	4

typedef struct {
	int dx;	// zmena v x
	int dy;	// zmena v y
} TahKonem;

TahKonem MozneTahy[8] = { {2, 1}, {1, 2}, {-1, 2}, {-2, 1},
{-2, -1}, {-1, -2}, {1, -2}, {2, -1} };	// osm moznych tahu konem

int Sachovnice[SirkaPole][VyskaPole];

void TiskSachovnice()
{
	for(int i = 0; i < SirkaPole; i++)
	{
		for(int j = 0; j < VyskaPole; j++)
		{
			cout << setw(4) << Sachovnice[i][j];
		}
		cout << endl << endl;
	}
}

void VymazSachovnici()
{
	for(int i = 0; i < SirkaPole; i++)
	{
		for(int j = 0; j < VyskaPole; j++)
		{
			Sachovnice[i][j] = -1;
		}
	}
}

void ZpetnyPruchod(int _PozX, int _PozY, int _CilX, int _CilY)
{
	int X, NoveX;
	int Y, NoveY;
	int iTah;

	X = _CilX;
	Y = _CilY;

	while((X != _PozX) || (Y != _PozY))
	{
		iTah = 0;

		do {
			NoveX = X + MozneTahy[iTah].dx;
			NoveY = Y + MozneTahy[iTah].dy;
			
			// pokud je pole stale na sachovnici
			if((NoveX >= 0) && (NoveX < SirkaPole) && (NoveY >= 0) && (NoveY < VyskaPole))
			{
				if(Sachovnice[NoveX][NoveY] == Sachovnice[X][Y] - 1)
				{
					// pokud se na pole da dostat jednim tahem, tak se na nej presuneme
					X = NoveX;
					Y = NoveY;

					cout << "Jdi na pole: (" << NoveX << " ; " << NoveY << ")" << endl;
					iTah = 0;
				}
				else
				{
					iTah++;	// zkus dalsi tah konem
				}
			}
			else
			{
				// pokud je pole mimo sachovnici, tak zkus opet dalsi tah
				iTah++;
			}
		} while(iTah != 0);
	}

	cout << endl;
}

void NajdiCestu(int _PozX, int _PozY, int _CilX, int _CilY)
{
	int iCislo = 1;	// kolikaty tah konem se pokousime udelat
	int NoveX, NoveY;
	int iTah = 0;	// tahy konem

	Sachovnice[_PozX][_PozY] = 0;	// prvni pole

	// dokud jsme nenavstivili pole na sachovnici
	while(Sachovnice[_CilX][_CilY] == - 1)
	{
		for(int i = 0; i < SirkaPole; i++)
			for(int j = 0; j < VyskaPole; j++)
			{
				// najdeme pole, ve kterych jsme byli v minulem pruchodu
				if(Sachovnice[i][j] == (iCislo - 1))
				{
					// udelame vsechny mozne tahy z tohoto pole
					for(iTah = 0; iTah < 8; iTah++)
					{
						NoveX = i + MozneTahy[iTah].dx;
						NoveY = j + MozneTahy[iTah].dy;

						// pokud je pole stale na sachovnici
						if((NoveX >= 0) && (NoveX < SirkaPole) && (NoveY >= 0) && (NoveY < VyskaPole))
						{
							if(Sachovnice[NoveX][NoveY] == -1)
							{
								// jeste jsme na tomto poli nebyli, tak si ho oznacime
								Sachovnice[NoveX][NoveY] = iCislo;
							}
						}
					}
				}
			}

		iCislo++;	// delame dalsi tah
	}

	// mame nalezenou cestu -> udelame zpetny pruchod
	ZpetnyPruchod(_PozX, _PozY, _CilX, _CilY);
}
		
int main(int argc, char* argv[])
{
	int PozX, PozY, CilX, CilY;

	cout << "Zadej x souradnici kone: ";
	cin >> PozX;
	cout << "Zadej y souradnici kone: ";
	cin >> PozY;

	cout << "Zadej x souradnici cile: ";
	cin >> CilX;
	cout << "Zadej y souradnici cile: ";
	cin >> CilY;


	if( ((PozX >= 0) && (PozX < SirkaPole) && (PozY >= 0) && (PozY < VyskaPole)) &&
	    ((CilX >= 0) && (CilX < SirkaPole) && (CilY >= 0) && (CilY < VyskaPole)) )
	{
		VymazSachovnici();

		NajdiCestu(PozX, PozY, CilX, CilY);

		TiskSachovnice();
	}
	else
	{
		cout << endl << "Zadana pozice lezi mimo hraci pole" << endl;
	}

	char c;
	cin >> c;

	return 0;
}

