#pragma once
//********************************************************************************************
//Trida zapouzdrujici fce pro praci se zvukovymi buffery
//********************************************************************************************
class OGGCODEC_API CSoundBuffer
{
protected:
	LPDIRECTSOUNDBUFFER			m_DSSoundBuffer;		//ukazatel na rozhrani IDirectSoundBuffer					
	DWORD						m_dwBufferSize;			//velikost bufferu v bajtech
	DWORD						m_dwCreationFlags;		//volby ktere jsem pouzili pri vytvareni bufferu
	
public:
	virtual HRESULT				Create(LPDIRECTSOUND lpDSound,DSBUFFERDESC* dsBufferDesc);
	HRESULT						RestoreBuffer(bool* bWasRestored);
	HRESULT						Play(DWORD dwPriority = 0,DWORD dwFlags = 0);
	HRESULT						Stop();
	HRESULT						Reset();
	HRESULT						SetFrequency(long lFrequency);
	HRESULT						SetPan(long lPan);
	HRESULT						SetVolume(long lVolume);

	bool						IsSoundPlaying();

	LPDIRECTSOUNDBUFFER			GetBuffer() {return m_DSSoundBuffer;}

	CSoundBuffer(void);
	~CSoundBuffer(void);
};
